module Presyntax.Presyntax where

import Data.Text (Text)

data Plicity
  = Im | Ex
  deriving (Eq, Show, Ord)

data Expr
  = Var Text
  | App Plicity Expr Expr
  | Lam Plicity Text Expr
  | Pi  Plicity Text Expr Expr
  deriving (Eq, Show, Ord)

data Statement
  = Decl Text Expr
  | Defn Text Expr
  deriving (Eq, Show, Ord)